unit SjrdLOGFile;

interface

uses
  Classes, SysUtils;

type
  TSjrdLOGFile = class
  // Classe grant un fichier LOG
  private
    FFile : TFileStream;
  public
    constructor Create(FileName : string; Append : boolean = False);
    destructor Destroy; override;
    procedure Add(Time, Title, Description : string); overload;
    procedure Add(Time : TDateTime; Title : string; Description : string = ''); overload;
    procedure Add(Title : string; Description : string = ''); overload;
  end;

implementation

constructor TSjrdLOGFile.Create(FileName : string; Append : boolean = False);
begin
  inherited Create;
  if Append then
    FFile := TFileStream.Create(FileName, fmOpenWrite or fmShareDenyNone)
  else
    FFile := TFileStream.Create(FileName, fmCreate or fmShareDenyNone);
end;

destructor TSjrdLOGFile.Destroy;
begin
  FFile.Free;
  inherited Destroy;
end;

procedure TSjrdLOGFile.Add(Time, Title, Description : string);
var Line : string;
begin
  Line := '['+Time+'] '+Title;
  if Description <> '' then Line := Line+' ; '+Description;
  Line := Line+#13#10;
  FFile.Seek(0, soFromEnd);
  FFile.WriteBuffer(Pointer(Line)^, Length(Line));
end;

procedure TSjrdLOGFile.Add(Time : TDateTime; Title : string; Description : string = '');
begin
  Add(DateTimeToStr(Time), Title, Description);
end;

procedure TSjrdLOGFile.Add(Title : string; Description : string = '');
begin
  Add(Now, Title, Description);
end;

end.
